Loading...
Searching...
No Matches
juce::MPEZoneLayout Class Reference

## Detailed Description

This class represents the current MPE zone layout of a device capable of handling MPE.

An MPE device can have up to two zones: a lower zone with master channel 1 and allocated MIDI channels increasing from channel 2, and an upper zone with master channel 16 and allocated MIDI channels decreasing from channel 15. MPE mode is enabled on a device when one of these zones is active and disabled when both are inactive.

Use the MPEMessages helper class to convert the zone layout represented by this object to MIDI message sequences that you can send to an Expressive MIDI device to set its zone layout, add zones etc.

See also
  MPEInstrument

The documentation for this class was generated from the following file:

- juce_audio_basics/mpe/juce_MPEZoneLayout.h

## Classes

class | Listener
| Listener class. More...

## Public Member Functions

| MPEZoneLayout ()=default
| Creates a layout with inactive upper and lower zones.
| MPEZoneLayout (MPEZone lower, MPEZone upper)
| Creates a layout with the given upper and lower zones.
| MPEZoneLayout (MPEZone singleZone)
| Creates a layout with a single upper or lower zone, leaving the other zone uninitialised.
| MPEZoneLayout (const MPEZoneLayout &other)
MPEZoneLayout & | operator= (const MPEZoneLayout &other)
bool | operator== (const MPEZoneLayout &other) const
bool | operator!= (const MPEZoneLayout &other) const
MPEZone | getLowerZone () const noexcept
| Returns a struct representing the lower MPE zone.
MPEZone | getUpperZone () const noexcept
| Returns a struct representing the upper MPE zone.
void | setLowerZone (int numMemberChannels=0, int perNotePitchbendRange=48, int masterPitchbendRange=2) noexcept
| Sets the lower zone of this layout.
void | setUpperZone (int numMemberChannels=0, int perNotePitchbendRange=48, int masterPitchbendRange=2) noexcept
| Sets the upper zone of this layout.
void | clearAllZones ()
| Clears the lower and upper zones of this layout, making them both inactive and disabling MPE mode.
bool | isActive () const
| Returns true if either of the zones are active.
void | processNextMidiEvent (const MidiMessage &message)
| Pass incoming MIDI messages to an object of this class if you want the zone layout to properly react to MPE RPN messages like an MPE device.
void | processNextMidiBuffer (const MidiBuffer &buffer)
| Pass incoming MIDI buffers to an object of this class if you want the zone layout to properly react to MPE RPN messages like an MPE device.
void | addListener (Listener *const listenerToAdd) noexcept
| Adds a listener.
void | removeListener (Listener *const listenerToRemove) noexcept
| Removes a listener.

## Constructors and Destructors

## MPEZoneLayout() [1/4]

juce::MPEZoneLayout::MPEZoneLayout | ( |  | ) |

default

Creates a layout with inactive upper and lower zones.

Referenced by MPEZoneLayout(), operator!=(), operator=(), operator==(), and juce::MPEZoneLayout::Listener::zoneLayoutChanged().

## MPEZoneLayout() [2/4]

juce::MPEZoneLayout::MPEZoneLayout | ( | MPEZone | lower,
|  | MPEZone | upper )

Creates a layout with the given upper and lower zones.

## MPEZoneLayout() [3/4]

juce::MPEZoneLayout::MPEZoneLayout | ( | MPEZone | singleZone | ) |

Creates a layout with a single upper or lower zone, leaving the other zone uninitialised.

## MPEZoneLayout() [4/4]

juce::MPEZoneLayout::MPEZoneLayout | ( | const MPEZoneLayout & | other | ) |

References MPEZoneLayout().

## Member Functions

## operator=()

MPEZoneLayout & juce::MPEZoneLayout::operator= | ( | const MPEZoneLayout & | other | ) |

References MPEZoneLayout().

## operator==()

bool juce::MPEZoneLayout::operator== | ( | const MPEZoneLayout & | other | ) | const

inline

References MPEZoneLayout().

## operator!=()

bool juce::MPEZoneLayout::operator!= | ( | const MPEZoneLayout & | other | ) | const

inline

References MPEZoneLayout().

## getLowerZone()

MPEZone juce::MPEZoneLayout::getLowerZone | ( |  | ) | const

inline noexcept

Returns a struct representing the lower MPE zone.

## getUpperZone()

MPEZone juce::MPEZoneLayout::getUpperZone | ( |  | ) | const

inline noexcept

Returns a struct representing the upper MPE zone.

## setLowerZone()

void juce::MPEZoneLayout::setLowerZone | ( | int | numMemberChannels = 0,
|  | int | perNotePitchbendRange = 48,
|  | int | masterPitchbendRange = 2 )

noexcept

Sets the lower zone of this layout.

## setUpperZone()

void juce::MPEZoneLayout::setUpperZone | ( | int | numMemberChannels = 0,
|  | int | perNotePitchbendRange = 48,
|  | int | masterPitchbendRange = 2 )

noexcept

Sets the upper zone of this layout.

References setUpperZone().

Referenced by setUpperZone().

## clearAllZones()

void juce::MPEZoneLayout::clearAllZones | ( |  | ) |

Clears the lower and upper zones of this layout, making them both inactive and disabling MPE mode.

References clearAllZones().

Referenced by clearAllZones().

## isActive()

bool juce::MPEZoneLayout::isActive | ( |  | ) | const

inline

Returns true if either of the zones are active.

References isActive().

Referenced by isActive().

## processNextMidiEvent()

void juce::MPEZoneLayout::processNextMidiEvent | ( | const MidiMessage & | message | ) |

Pass incoming MIDI messages to an object of this class if you want the zone layout to properly react to MPE RPN messages like an MPE device.

MPEMessages::rpnNumber will add or remove zones; RPN 0 will set the per-note or master pitchbend ranges.

Any other MIDI messages will be ignored by this class.

See also
  MPEMessages

## processNextMidiBuffer()

void juce::MPEZoneLayout::processNextMidiBuffer | ( | const MidiBuffer & | buffer | ) |

Pass incoming MIDI buffers to an object of this class if you want the zone layout to properly react to MPE RPN messages like an MPE device.

MPEMessages::rpnNumber will add or remove zones; RPN 0 will set the per-note or master pitchbend ranges.

Any other MIDI messages will be ignored by this class.

See also
  MPEMessages

## addListener()

void juce::MPEZoneLayout::addListener | ( | Listener *const | listenerToAdd | ) |

noexcept

Adds a listener.

## removeListener()

void juce::MPEZoneLayout::removeListener | ( | Listener *const | listenerToRemove | ) |

noexcept

Removes a listener.

References juce::MPEZone::lower.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited